-- p2.py: P2 Mhs definitions


-- @(#) $Header: /cs/research/pp/hubris/pp-beta/Format/p2flatten/RCS/p2.py,v 5.0 90/09/20 16:01:15 pp Exp Locker: pp $
--
-- $Log:	p2.py,v $
-- Revision 5.0  90/09/20  16:01:15  pp
-- rcsforce : 5.0 public release
-- 
--



P2 DEFINITIONS IMPLICIT TAGS ::=

BEGIN

InformationObject ::=
	CHOICE {
            ipm[0] IPM,

            ipn[1] IPN
        }


-- IP-message UAPDU

IPM ::=
        SEQUENCE {
            heading
                Heading,

            body
                Body
        }


-- heading

Heading ::=
	ANY

-- body

Body ::=
        SEQUENCE OF BodyPart

BodyPart ::=

        CHOICE {
            ia5-text		[0] IA5TextBodyPart,

            tlx			[1] TLXBodyPart,

            voice		[2] VoiceBodyPart,

            g3-facsimile	[3] G3FacsimileBodyPart,

            g4-class1		[4] G4Class1BodyPart,

            teletex		[5] TeletexBodyPart,

            videotex		[6] VideotexBodyPart,

            encrypted		[8] EncryptedBodyPart,

            message		[9] MessageBodyPart,

            sfd			[10] SFDBodyPart,

            mixed-mode		[11] MixedModeBodyPart,

	    bilaterally-defined	[14] BilaterallyDefinedBodyPart,

            nationally-defined	[7] NationallyDefinedBodyPart,

	    externally-defined	[15] ExternallyDefinedBodyPart,

            odif		[12] ODIFBodyPart,

	    iso6937Text		[13] ISO6937TextBodyPart
        }


-- body part types

IA5TextBodyPart ::= SEQUENCE {
		parameters   IA5Parameters,
		data	     IA5TextData
		}

IA5Parameters ::= SET {
	      repertoire [0] Repertoire DEFAULT ia5
	      }

IA5TextData ::= IA5String

Repertoire ::= ENUMERATED {
	   ita2 (2),
	   ia5	(5)
	   }

TLXBodyPart ::= ANY

VoiceBodyPart ::= ANY

G3FacsimileBodyPart ::= ANY

G4Class1BodyPart ::= ANY

MixedModeBodyPart ::= ANY

TeletexBodyPart ::= ANY

VideotexBodyPart ::= ANY

EncryptedBodyPart ::= ANY

MessageBodyPart ::= SEQUENCE {
		parameters	MessageParameters,
		data		MessageData
		}

MessageParameters ::= SET {
		  delivery-time		[0] MessageDeliveryTime OPTIONAL,
		  delivery-envelope	[1] ANY OPTIONAL
		  }

MessageDeliveryTime ::= Time

MessageData ::= IPM

SFDBodyPart ::= ANY

ODIFBodyPart ::=
        -- from appendix A minutes of the PODA Munich meeting July 6th 1988.
        OCTET STRING

BilaterallyDefinedBodyPart ::= ANY

NationallyDefinedBodyPart ::= ANY

ExternallyDefinedBodyPart ::= ANY

ISO6937TextBodyPart ::= ANY

-- IPN

IPN ::= SET {
	-- common-fields
	subject-ipm			SubjectIPMField,
	ipn-originator		[1]	ANY OPTIONAL,
	ipm-preferred-recipient	[2]	ANY OPTIONAL,
	conversion-eits			ConversionEITsField OPTIONAL,
	choice [0] CHOICE {
	       non-receipt-fields	[0]	NonReceiptFields,
	       receipt-fields		[1]	ANY
	       }
	}

NonReceiptFields ::= SET {
	non-receipt-reason	[0]	ANY,
	discard-reason		[1]	ANY OPTIONAL,
	auto-forward-comment	[2]	ANY OPTIONAL,
	returned-ipm		[3]	ReturnedIPMField OPTIONAL
	}

SubjectIPMField	::= IPMIdentifier

IPMIdentifier ::= [APPLICATION 11] SET {
	user			       ORName OPTIONAL,
	user-relative-identifier       LocalIPMIdentifier
	}

LocalIPMIdentifier ::= PrintableString
        (SIZE (0..ub-local-ipm-identifier))

ORName ::= [APPLICATION 0] SEQUENCE {
	x1 ANY,
	x2 ANY OPTIONAL}

ConversionEITsField ::= EncodedInformationTypes

EncodedInformationTypes ::= [APPLICATION 5] SET {
	built-in-encoded-information-types [0] ANY,
	external-encoded-information-types [4] ANY OPTIONAL }

-- Non-receipt fields

ReturnedIPMField ::= IPM

Time ::= UTCTime

END
